include	clib.inc
include	mouse.inc
ifdef __MOUSE__
ifndef	__f__

MOUSEINT 	EQU 33h
OFFSETVECTOR	EQU MOUSEINT*4

	.code

__mouse	db 0	; Installed
__mbool	db 0	; Visible
__mflag	db 0	; Mouse State

mousep	proc _CType public
	xor	ax,ax
	cmp	cs:[__mouse],al
	je	@F
	push	bx
	push	cx
	push	dx
	mov	al,6
	int	33h
	or	al,al
	pop	dx
	pop	cx
	pop	bx
      @@:
	ret
mousep	endp

mouseon	proc	_CType public
	mov	ax,1
	cmp	al,cs:[__mbool]
	je	@F
	cmp	ah,cs:[__mouse]
	je	@F
	mov	cs:[__mbool],al
	int	33h
      @@:
	ret
mouseon	endp

mouseoff proc	_CType public
	xor	ax,ax
	cmp	al,cs:[__mbool]
	jz	@F
	mov	cs:[__mbool],al
	mov	ax,2
	int	33h
      @@:
	ret
mouseoff endp

mousex	proc	_CType public
	push	bx
	push	cx
	push	dx
	xor	ax,ax
	cmp	al,cs:[__mouse]
	je	@F
	mov	al,3
	int	33h
	mov	ax,cx
	shr	ax,3
      @@:
	pop	dx
	pop	cx
	pop	bx
	ret
mousex	endp

mousey	proc	_CType public
	push	bx
	push	cx
	push	dx
	xor	ax,ax
	cmp	al,cs:[__mouse]
	je	@F
	mov	ax,3
	int	33h
	mov	ax,dx
	shr	ax,3
      @@:
	pop	dx
	pop	cx
	pop	bx
	ret
mousey	endp

mousehide proc	_CType public
	push	ax
	call	mouseoff
	shr	al,1
	mov	ah,cs:[__mflag]
	shl	ah,1
	or	al,ah
	mov	cs:[__mflag],al
	pop	ax
	ret
mousehide endp

mouseshow proc	_CType public
	push	ax
	mov	al,cs:[__mflag]
	shr	al,1
	mov	cs:[__mflag],al
	jnc	@F
	call	mouseon
      @@:
	pop	ax
	ret
mouseshow endp

mouseset proc _CType public
	call	mousehide
	mov	cs:[__mouse],al
	call	mouseshow
	ret
mouseset endp

mouseget proc _CType public
	mov	ah,cs:[__mouse]
	mov	al,cs:[__mbool]
	mov	dl,cs:[__mflag]
	ret
mouseget endp

Install:
	xor	ax,ax
	mov	cs:[__mouse],al
	mov	es,ax
	cmp	ax,es:[OFFSETVECTOR+2]
	je	mouseinit_00
	les	bx,es:[OFFSETVECTOR]
	cmp	byte ptr es:[bx],0CFh
	je	mouseinit_00
	int	33h
	test	ax,ax
	jz	mouseinit_00
	inc	cs:[__mouse]
    mouseinit_00:
	ret

pragma_init Install,100


else  ; __f__

include	keyb.inc
include	stdio.inc

KEY_EVENT	EQU 1
MOUSE_EVENT	EQU 2
UpdateMouseEvent proto _CType :ptr INPUT_RECORD

	.code

	ASSUME	ebx:ptr INPUT_RECORD

mousep	proc _CType uses ebx esi edi
local	Count:dword
local	Event:INPUT_RECORD
	sub	edi,edi
	lea	ebx,Event
	invoke	GetNumberOfConsoleInputEvents,OFSH_INPUT,addr Count
	test	eax,eax
	jz	mousep_end
	mov	esi,Count
    mousep_loop:
    	test	esi,esi
	jz	mousep_end
    	invoke	PeekConsoleInput,OFSH_INPUT,ebx,1,addr Count
	cmp	Count,0
	je	mousep_end
	cmp	[ebx].EventType,KEY_EVENT
	je	mousep_end
	cmp	[ebx].EventType,MOUSE_EVENT
	jne	@F
	invoke	UpdateMouseEvent,ebx
	mov	edi,eax
      @@:
	invoke	ReadConsoleInput,OFSH_INPUT,ebx,1,addr Count
	dec	esi
	jmp	mousep_loop
    mousep_end:
	mov	eax,keyshift
	movzx	eax,word ptr [eax+2]
	and	eax,3
	ret
mousep	endp

mousex	proc _CType
	mov eax,mouse_current_x
	ret
mousex	endp

mousey	proc _CType
	mov eax,mouse_current_y
	ret
mousey	endp

mouseon	proc _CType public
	ret
mouseon	endp

mouseoff proc _CType public
	ret
mouseoff endp

endif ; __f__
endif ; __MOUSE__
	end
